//+-------------------------------------------------------------------+
//|                                      MF_Fractals Color 0-0030.mq4 |
//|                                      Copyright  2006 Zhunko      |
//|22.08.2007                            MF ZHUNKO zhunko@mail.ru     |
//+-------------------------------------------------------------------+
//|        "Fractals".     |
//|                       Copyright  2005, MetaQuotes Software Corp. |
//|                                         http://www.metaquotes.net |
//+-------------------------------------------------------------------+
//|                      .                        |
//| 1.   MF_Fractals Color 0-0020  20.11.2006 .    |
//| 1.1.       - |
//|       .                                                  |
//| 1.2.    .                 |
//| 2.   MF_Fractals Color 0-0030  20.11.2006 .    |
//| 2.1.  "".                                      |
//+-------------------------------------------------------------------+
#property copyright "Copyright  2006 Zhunko"
#property link      "zhunko@mail.ru"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_color2 Red
//---- input parameters
extern int Size = 1;       //   .
extern bool ALERT = false; //   "".          .
//---- buffers
double ExtUpFractalsBuffer[];
double ExtDownFractalsBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
 {
  // indicator buffers mapping
  SetIndexBuffer(0, ExtUpFractalsBuffer);
  SetIndexBuffer(1, ExtDownFractalsBuffer);
  //  drawing settings
  SetIndexStyle (0, DRAW_ARROW, EMPTY, Size);
  SetIndexArrow (0, 217);
  SetIndexStyle (1, DRAW_ARROW, EMPTY, Size);
  SetIndexArrow (1, 218);
  //----
  SetIndexEmptyValue (0, 0.0);
  SetIndexEmptyValue (1, 0.0);
  // name for DataWindow
  SetIndexLabel (0, "Fractal Up");
  SetIndexLabel (1, "Fractal Down");
  // initialization done
  return(0);
 }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
 {
  int Dist;
  
  if (Period() == 1)     Dist = 1;
  if (Period() == 5)     Dist = 1;
  if (Period() == 15)    Dist = 1;
  if (Period() == 30)    Dist = 2;
  if (Period() == 60)    Dist = 3;
  if (Period() == 240)   Dist = 5;
  if (Period() == 1440)  Dist = 15;
  if (Period() == 10080) Dist = 60;
  if (Period() == 43200) Dist = 80;

  int    i,nCountedBars;
  bool   bFound;
  bool   AlertUP, AlertDOWN;
  double dCurrent;
  nCountedBars=IndicatorCounted();
  // last counted bar will be recounted    
  if (nCountedBars <= 2) i = Bars - nCountedBars + 8;
  if (nCountedBars > 2)
   {
    nCountedBars--;
    i = Bars - nCountedBars + 8;
   }
  // Up and Down Fractals
  while (i >= 2)
   {
    // Fractals up
    bFound = false;
    dCurrent = High[i];
    if (dCurrent > High[i + 1] && dCurrent > High[i + 2] && dCurrent > High[i - 1] && dCurrent > High[i - 2])
     {
      bFound = true;
      AlertUP = true;
      ExtUpFractalsBuffer[i] = dCurrent + Dist * Point;
     }
    // 6 bars Fractal
    if (!bFound && (Bars - i - 1) >= 3)
     {
      if (dCurrent == High[i + 1] && dCurrent > High[i + 2] && dCurrent > High[i + 3] && dCurrent > High[i - 1] && dCurrent > High[i - 2])
       {
        bFound = true;
        AlertUP = true;
        ExtUpFractalsBuffer[i] = dCurrent + Dist * Point;
       }
     }         
    // 7 bars Fractal
    if (!bFound && (Bars - i - 1) >= 4)
     {   
      if (dCurrent >= High[i + 1] && dCurrent == High[i + 2] && dCurrent > High[i + 3] && dCurrent > High[i + 4] && dCurrent > High[i - 1] && dCurrent > High[i - 2])
       {
        bFound = true;
        AlertUP = true;
        ExtUpFractalsBuffer[i] = dCurrent + Dist * Point;
       }
     }  
    // 8 bars Fractal                          
    if (!bFound && (Bars - i - 1) >= 5)
     {   
      if (dCurrent >= High[i + 1] && dCurrent==  High[i + 2] && dCurrent == High[i + 3] && dCurrent > High[i + 4] && dCurrent > High[i + 5] && dCurrent > High[i - 1] && dCurrent > High[i - 2])
       {
        bFound = true;
        AlertUP = true;
        ExtUpFractalsBuffer[i] = dCurrent + Dist * Point;
       }
     } 
    // 9 bars Fractal                                        
    if (!bFound && (Bars - i - 1) >= 6)
     {   
      if (dCurrent >= High[i + 1] && dCurrent == High[i + 2] && dCurrent >= High[i + 3] && dCurrent == High[i + 4] && dCurrent > High[i + 5] && dCurrent > High[i + 6] && dCurrent > High[i - 1] && dCurrent > High[i - 2])
       {
        bFound = true;
        AlertUP = true;
        ExtUpFractalsBuffer[i] = dCurrent + Dist * Point;
       }
     }                                    
    // Fractals down
    bFound = false;
    dCurrent = Low[i];
    if (dCurrent < Low[i + 1] && dCurrent < Low[i + 2] && dCurrent < Low[i - 1] && dCurrent < Low[i - 2])
     {
      bFound = true;
      AlertDOWN = true;
      ExtDownFractalsBuffer[i] = dCurrent - Dist * Point;
     }
    // 6 bars Fractal
    if (!bFound && (Bars - i - 1) >= 3)
     {
      if (dCurrent == Low[i + 1] && dCurrent < Low[i + 2] && dCurrent < Low[i + 3] && dCurrent < Low[i - 1] && dCurrent < Low[i - 2])
       {
        bFound = true;
        AlertDOWN = true;
        ExtDownFractalsBuffer[i] = dCurrent - Dist * Point;
       }                      
     }         
    // 7 bars Fractal
    if (!bFound && (Bars - i - 1) >= 4)
     {   
      if (dCurrent <= Low[i + 1] && dCurrent == Low[i + 2] && dCurrent < Low[i + 3] && dCurrent < Low[i + 4] && dCurrent < Low[i - 1] && dCurrent < Low[i - 2])
       {
        bFound = true;
        AlertDOWN = true;
        ExtDownFractalsBuffer[i] = dCurrent - Dist * Point;
       }                      
     }  
    // 8 bars Fractal                          
    if (!bFound && (Bars - i - 1) >= 5)
     {   
      if (dCurrent <= Low[i + 1] && dCurrent == Low[i + 2] && dCurrent == Low[i + 3] && dCurrent < Low[i + 4] && dCurrent < Low[i + 5] && dCurrent < Low[i - 1] && dCurrent < Low[i - 2])
       {
        bFound = true;
        AlertDOWN = true;
        ExtDownFractalsBuffer[i] = dCurrent - Dist * Point;
       }                      
     } 
    // 9 bars Fractal                                        
    if (!bFound && (Bars - i - 1) >= 6)
     {   
      if (dCurrent <= Low[i + 1] && dCurrent == Low[i + 2] && dCurrent <= Low[i + 3] && dCurrent == Low[i + 4] && dCurrent < Low[i + 5] && dCurrent < Low[i + 6] && dCurrent < Low[i - 1] && dCurrent < Low[i - 2])
       {
        bFound = true;
        AlertDOWN = true;
        ExtDownFractalsBuffer[i] = dCurrent - Dist * Point;
       }                      
     }                                    
    i--;
   }
  if (ALERT == true && AlertUP == true) Alert ("!!!   !!!");
  if (ALERT == true && AlertDOWN == true) Alert ("!!!   !!!");
  return(0);
 }
//+------------------------------------------------------------------+